// Объявляем переменные
String StrVal = "";
int pinA = 2; // Пины прерываний
int pinB = 3; // Пины прерываний
int pinC = 4; // Внутренняя кнопка энкодера
long val = 0; //  Значение частоты по умолчанию
int valstep = 10; // Шаг энкодера по умолчанию

volatile long pause    = 10;  // Пауза для борьбы с дребезгом

volatile long lastTurn = 0;   // Переменная для хранения времени последнего изменения энкодера


volatile int count = 0;       // Счетчик оборотов
int actualcount    = 0;       // Временная переменная определяющая изменение основного счетчика

volatile int state = 0;       // Статус одного шага - от 0 до 4 в одну сторону, от 0 до -4 - в другую
volatile int stateC = 0;      //  Статус нажатия кнопки

volatile int pinAValue = 0;   // Переменные хранящие состояние пина, для экономии времени
volatile int pinBValue = 0;   // Переменные хранящие состояние пина, для экономии времени
volatile int pinCValue = 0;   // Состояние кнопки

void setup()
{
  pinMode(pinA, INPUT);           // Пины в режим приема INPUT
  pinMode(pinB, INPUT);           // Пины в режим приема INPUT
  pinMode(pinC, INPUT);           // Пины в режим приема INPUT
  
  attachInterrupt(0, A, CHANGE);  // Настраиваем обработчик прерываний по изменению сигнала
  attachInterrupt(1, B, CHANGE);  // Настраиваем обработчик прерываний по изменению сигнала

  Serial.begin(57600);  // Настраиваем серийный порт
  Serial.print("AI0;"); // Инициализация  CAT программы по протоколу TS 2000

}

void loop() 
{

      if (actualcount != count) {    // Обрабатываем изменение значений счетчика оборотов
      if (abs(count) < 25) {         // Предохранитель от ложных скачков
             
      if (stateC == 0) {             // Выставляем значение шага энкодера по нажатию кнопки если  кнопка нажата то шаг большой
        valstep = 10; }
        else {valstep = 1000;}
       
      Serial.print("FA;");        // Выдаем запрос текущей частоты
      String inData = Serial.readStringUntil(';'); //Принимаем значение частоты
      inData.remove(0,2);    // Удаляем FA перед цифрами
      val = inData.toInt(); // Получаем цифровое значение частоты 
      val = val + valstep * count; // инкрементируем
      StrVal = String(val, DEC); // получаем строковое значение
      int check =  StrVal.length();
      while (check < 11) {            // добавляем в строке до 11 знаков числа
        StrVal = "0" + StrVal;
        check =  StrVal.length();
      }
 
      Serial.print("FA");    //  передаем новую частоту
      Serial.print(StrVal);
      Serial.print(";"); 
            inData = "";
     
      }     

}
        actualcount = 0; // Обнуляем счетчики
        count = 0;
} 
void A()
{
  if (micros() - lastTurn < pause) return;  // Если с момента последнего изменения состояния не прошло
  // достаточно времени - выходим из прерывания
  pinAValue = digitalRead(pinA);            // Получаем состояние пинов A и B и C
  pinBValue = digitalRead(pinB);
  pinCValue = digitalRead(pinC);
  
  cli();    // Запрещаем обработку прерываний, чтобы не отвлекаться
  if (state == 0  && !pinAValue &&  pinBValue || state == 2  && pinAValue && !pinBValue) {
    state += 1; // Если выполняется условие, наращиваем переменную state
    lastTurn = micros();
  }
  if (state == -1 && !pinAValue && !pinBValue || state == -3 && pinAValue &&  pinBValue) {
    state -= 1; // Если выполняется условие, наращиваем в минус переменную state
    lastTurn = micros();
  }
   // Кнопка если не нажата значение 0 всегда
   if (stateC == 0 && !pinCValue == 1 ) {
    stateC = 1; }// 
   if (stateC == 1 && !pinCValue == 0 ) {
    stateC = 0; }// 
  

  setCount(state); // Проверяем не было ли полного шага из 4 изменений сигналов (2 импульсов)
  
  sei(); // Разрешаем обработку прерываний

  if (pinAValue && pinBValue && state != 0) state = 0; // Если что-то пошло не так, возвращаем статус в исходное состояние
}
void B()
{
  if (micros() - lastTurn < pause) return;
  pinAValue = digitalRead(pinA);
  pinBValue = digitalRead(pinB);
  pinCValue = digitalRead(pinC);

  cli();
  if (state == 1 && !pinAValue && !pinBValue || state == 3 && pinAValue && pinBValue) {
    state += 1; // Если выполняется условие, наращиваем переменную state
    lastTurn = micros();
  }
  if (state == 0 && pinAValue && !pinBValue || state == -2 && !pinAValue && pinBValue) {
    state -= 1; // Если выполняется условие, наращиваем в минус переменную state
    lastTurn = micros();
  }

   // Кнопка если не нажата значение 0 всегда
   if (stateC == 0 && !pinCValue == 1 ) {
    stateC = 1; }// 
   if (stateC == 1 && !pinCValue == 0 ) {
    stateC = 0; }// 
  
  setCount(state); // Проверяем не было ли полного шага из 4 изменений сигналов (2 импульсов)
 
  sei();
  
  if (pinAValue && pinBValue && state != 0) state = 0; // Если что-то пошло не так, возвращаем статус в исходное состояние
}




void setCount(int state) {          // Устанавливаем значение счетчика
  if (state == 4 || state == -4) {  // Если переменная state приняла заданное значение приращения
    count += (int)(state / 4);      // Увеличиваем/уменьшаем счетчик
    lastTurn = micros();            // Запоминаем последнее изменение
  }
}
